const _path = require("path");
  
const creat = (
    nginx_user="www-data",
    usock="___nv_question_repo___",
    dbname="wangpoapp",
    tbl='qrepo',
    workdir = "./",    
)=> {
     
    let P = _path.resolve(workdir);
    usock = _path.join(P,usock);    

    let tem = `
const _qrepo = require("nv-question-repo-srv")._eng;
const _user  = require("nv-remote-user-local-eng");
const _cmmn                        = require("nv-remote-user-local-eng")._cmmn;
const _is_of_same_user = (uid0,uid1) => (uid0.split(_user._eng.Attr.SP)[0] === uid1.split(_user._eng.Attr.SP)[0])

const _validate = async(reqD,route,srv) => {
        let req_headers = reqD.headers;
        let req_body    = _cmmn.buf2json(reqD.body);
        let USER        = srv.cfg.USER;            //用户池
        let {u,ka}      = USER.tpool;
        let userid      = req_headers.utoken?u.get_userid(req_headers.utoken):undefined;
        if(userid) {
            let is_admin = (userid === '/___未划分___/admin');
            let is_debug = (userid === '/___未划分___/___debug___');
            if(is_admin || is_debug) {
                 return([true,userid])
            } else {
                if(
                     route.includes("update") ||           //修改: owner 自己
                     route.includes("del")             //删除: owner 自己
                ) {
                      let data    = req_body;
                      let id      = data.id;
                      let db      = srv.db;
                      let r       = await db._get_one_with_id(id);
                      if(r.oper!==undefined && _is_of_same_user(r.oper,userid)) {
                           return([true,userid])
                      } else {
                          return([false,'only admin or debug or owner can update/del'])
                      }
                } else {
                    return([true,userid])
                }  
            }
        } else {
            return([false,null])
        }
}


module.exports = async (
    USER=globalThis.USER,
    OSS=globalThis.OSS,
    validate=_validate,
)=> {
    let srv = await _qrepo.creat({
        USER,
        OSS,
        validate,
        sock:{
            nginx_user:"${nginx_user}",
            usock:"${usock}",
        },
        db: {
            dbname: "${dbname}",
            tbl: "${tbl}"
        }
    });
    return(srv)
}
`;
    return(tem)
}


module.exports = {
    creat
}
